/**
 */
package genericAccessorMethods.util;

import genericAccessorMethods.AbstractEntry;
import genericAccessorMethods.AbstractLibrary;
import genericAccessorMethods.Book;
import genericAccessorMethods.BookLibrary;
import genericAccessorMethods.Comedy;
import genericAccessorMethods.GenericAccessorMethodsPackage;
import genericAccessorMethods.Movie;
import genericAccessorMethods.MovieLibrary;
import genericAccessorMethods.SciFi;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * @see genericAccessorMethods.GenericAccessorMethodsPackage
 * @generated
 */
public class GenericAccessorMethodsSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static GenericAccessorMethodsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public GenericAccessorMethodsSwitch() {
		if (modelPackage == null) {
			modelPackage = GenericAccessorMethodsPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case GenericAccessorMethodsPackage.ABSTRACT_LIBRARY: {
				AbstractLibrary abstractLibrary = (AbstractLibrary)theEObject;
				T result = caseAbstractLibrary(abstractLibrary);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GenericAccessorMethodsPackage.BOOK_LIBRARY: {
				BookLibrary bookLibrary = (BookLibrary)theEObject;
				T result = caseBookLibrary(bookLibrary);
				if (result == null) result = caseAbstractLibrary(bookLibrary);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GenericAccessorMethodsPackage.MOVIE_LIBRARY: {
				MovieLibrary movieLibrary = (MovieLibrary)theEObject;
				T result = caseMovieLibrary(movieLibrary);
				if (result == null) result = caseAbstractLibrary(movieLibrary);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GenericAccessorMethodsPackage.ABSTRACT_ENTRY: {
				AbstractEntry abstractEntry = (AbstractEntry)theEObject;
				T result = caseAbstractEntry(abstractEntry);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GenericAccessorMethodsPackage.BOOK: {
				Book book = (Book)theEObject;
				T result = caseBook(book);
				if (result == null) result = caseAbstractEntry(book);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GenericAccessorMethodsPackage.MOVIE: {
				Movie movie = (Movie)theEObject;
				T result = caseMovie(movie);
				if (result == null) result = caseAbstractEntry(movie);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GenericAccessorMethodsPackage.SCI_FI: {
				SciFi sciFi = (SciFi)theEObject;
				T result = caseSciFi(sciFi);
				if (result == null) result = caseMovie(sciFi);
				if (result == null) result = caseAbstractEntry(sciFi);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GenericAccessorMethodsPackage.COMEDY: {
				Comedy comedy = (Comedy)theEObject;
				T result = caseComedy(comedy);
				if (result == null) result = caseMovie(comedy);
				if (result == null) result = caseAbstractEntry(comedy);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Abstract Library</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Abstract Library</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAbstractLibrary(AbstractLibrary object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Book Library</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Book Library</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBookLibrary(BookLibrary object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Movie Library</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Movie Library</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMovieLibrary(MovieLibrary object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Abstract Entry</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Abstract Entry</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAbstractEntry(AbstractEntry object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Book</em>'. <!-- begin-user-doc --> This implementation returns null;
	 * returning a non-null result will terminate the switch. <!-- end-user-doc
	 * -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Book</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBook(Book object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Movie</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Movie</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMovie(Movie object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sci Fi</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sci Fi</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSciFi(SciFi object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Comedy</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Comedy</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseComedy(Comedy object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} // GenericAccessorMethodsSwitch
