/**
 */
package genericAttributes;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc --> The <b>Package</b> for the model. It contains
 * accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see genericAttributes.GenericAttributesFactory
 * @model kind="package"
 * @generated
 */
public interface GenericAttributesPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "genericAttributes";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "genericAttributes";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "genericAttributes";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	GenericAttributesPackage eINSTANCE = genericAttributes.impl.GenericAttributesPackageImpl.init();

	/**
	 * The meta object id for the '{@link genericAttributes.impl.AbstractLibraryImpl <em>Abstract Library</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see genericAttributes.impl.AbstractLibraryImpl
	 * @see genericAttributes.impl.GenericAttributesPackageImpl#getAbstractLibrary()
	 * @generated
	 */
	int ABSTRACT_LIBRARY = 0;

	/**
	 * The feature id for the '<em><b>Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_LIBRARY__ENTRIES = 0;

	/**
	 * The number of structural features of the '<em>Abstract Library</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_LIBRARY_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link genericAttributes.impl.BookLibraryImpl <em>Book Library</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see genericAttributes.impl.BookLibraryImpl
	 * @see genericAttributes.impl.GenericAttributesPackageImpl#getBookLibrary()
	 * @generated
	 */
	int BOOK_LIBRARY = 1;

	/**
	 * The feature id for the '<em><b>Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOK_LIBRARY__ENTRIES = ABSTRACT_LIBRARY__ENTRIES;

	/**
	 * The number of structural features of the '<em>Book Library</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOK_LIBRARY_FEATURE_COUNT = ABSTRACT_LIBRARY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link genericAttributes.impl.MovieLibraryImpl <em>Movie Library</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see genericAttributes.impl.MovieLibraryImpl
	 * @see genericAttributes.impl.GenericAttributesPackageImpl#getMovieLibrary()
	 * @generated
	 */
	int MOVIE_LIBRARY = 2;

	/**
	 * The feature id for the '<em><b>Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOVIE_LIBRARY__ENTRIES = ABSTRACT_LIBRARY__ENTRIES;

	/**
	 * The number of structural features of the '<em>Movie Library</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOVIE_LIBRARY_FEATURE_COUNT = ABSTRACT_LIBRARY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link genericAttributes.impl.AbstractEntryImpl <em>Abstract Entry</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see genericAttributes.impl.AbstractEntryImpl
	 * @see genericAttributes.impl.GenericAttributesPackageImpl#getAbstractEntry()
	 * @generated
	 */
	int ABSTRACT_ENTRY = 3;

	/**
	 * The number of structural features of the '<em>Abstract Entry</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ENTRY_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link genericAttributes.impl.BookImpl <em>Book</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see genericAttributes.impl.BookImpl
	 * @see genericAttributes.impl.GenericAttributesPackageImpl#getBook()
	 * @generated
	 */
	int BOOK = 4;

	/**
	 * The number of structural features of the '<em>Book</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BOOK_FEATURE_COUNT = ABSTRACT_ENTRY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link genericAttributes.impl.MovieImpl <em>Movie</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see genericAttributes.impl.MovieImpl
	 * @see genericAttributes.impl.GenericAttributesPackageImpl#getMovie()
	 * @generated
	 */
	int MOVIE = 5;

	/**
	 * The number of structural features of the '<em>Movie</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MOVIE_FEATURE_COUNT = ABSTRACT_ENTRY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link genericAttributes.impl.SciFiImpl <em>Sci Fi</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see genericAttributes.impl.SciFiImpl
	 * @see genericAttributes.impl.GenericAttributesPackageImpl#getSciFi()
	 * @generated
	 */
	int SCI_FI = 6;

	/**
	 * The number of structural features of the '<em>Sci Fi</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCI_FI_FEATURE_COUNT = MOVIE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link genericAttributes.impl.ComedyImpl <em>Comedy</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see genericAttributes.impl.ComedyImpl
	 * @see genericAttributes.impl.GenericAttributesPackageImpl#getComedy()
	 * @generated
	 */
	int COMEDY = 7;

	/**
	 * The number of structural features of the '<em>Comedy</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMEDY_FEATURE_COUNT = MOVIE_FEATURE_COUNT + 0;

	/**
	 * Returns the meta object for class '{@link genericAttributes.AbstractLibrary <em>Abstract Library</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Library</em>'.
	 * @see genericAttributes.AbstractLibrary
	 * @generated
	 */
	EClass getAbstractLibrary();

	/**
	 * Returns the meta object for the containment reference list '{@link genericAttributes.AbstractLibrary#getEntries <em>Entries</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Entries</em>'.
	 * @see genericAttributes.AbstractLibrary#getEntries()
	 * @see #getAbstractLibrary()
	 * @generated
	 */
	EReference getAbstractLibrary_Entries();

	/**
	 * Returns the meta object for class '{@link genericAttributes.BookLibrary <em>Book Library</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Book Library</em>'.
	 * @see genericAttributes.BookLibrary
	 * @generated
	 */
	EClass getBookLibrary();

	/**
	 * Returns the meta object for class '{@link genericAttributes.MovieLibrary <em>Movie Library</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Movie Library</em>'.
	 * @see genericAttributes.MovieLibrary
	 * @generated
	 */
	EClass getMovieLibrary();

	/**
	 * Returns the meta object for class '
	 * {@link genericAttributes.AbstractEntry <em>Abstract Entry</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Abstract Entry</em>'.
	 * @see genericAttributes.AbstractEntry
	 * @generated
	 */
	EClass getAbstractEntry();

	/**
	 * Returns the meta object for class '{@link genericAttributes.Book <em>Book</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Book</em>'.
	 * @see genericAttributes.Book
	 * @generated
	 */
	EClass getBook();

	/**
	 * Returns the meta object for class '{@link genericAttributes.Movie <em>Movie</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Movie</em>'.
	 * @see genericAttributes.Movie
	 * @generated
	 */
	EClass getMovie();

	/**
	 * Returns the meta object for class '{@link genericAttributes.SciFi <em>Sci Fi</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sci Fi</em>'.
	 * @see genericAttributes.SciFi
	 * @generated
	 */
	EClass getSciFi();

	/**
	 * Returns the meta object for class '{@link genericAttributes.Comedy <em>Comedy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comedy</em>'.
	 * @see genericAttributes.Comedy
	 * @generated
	 */
	EClass getComedy();

	/**
	 * Returns the factory that creates the instances of the model. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	GenericAttributesFactory getGenericAttributesFactory();

	/**
	 * <!-- begin-user-doc --> Defines literals for the meta objects that
	 * represent
	 * <ul>
	 * <li>each class,</li>
	 * <li>each feature of each class,</li>
	 * <li>each enum,</li>
	 * <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link genericAttributes.impl.AbstractLibraryImpl <em>Abstract Library</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see genericAttributes.impl.AbstractLibraryImpl
		 * @see genericAttributes.impl.GenericAttributesPackageImpl#getAbstractLibrary()
		 * @generated
		 */
		EClass ABSTRACT_LIBRARY = eINSTANCE.getAbstractLibrary();

		/**
		 * The meta object literal for the '<em><b>Entries</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_LIBRARY__ENTRIES = eINSTANCE.getAbstractLibrary_Entries();

		/**
		 * The meta object literal for the '{@link genericAttributes.impl.BookLibraryImpl <em>Book Library</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see genericAttributes.impl.BookLibraryImpl
		 * @see genericAttributes.impl.GenericAttributesPackageImpl#getBookLibrary()
		 * @generated
		 */
		EClass BOOK_LIBRARY = eINSTANCE.getBookLibrary();

		/**
		 * The meta object literal for the '{@link genericAttributes.impl.MovieLibraryImpl <em>Movie Library</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see genericAttributes.impl.MovieLibraryImpl
		 * @see genericAttributes.impl.GenericAttributesPackageImpl#getMovieLibrary()
		 * @generated
		 */
		EClass MOVIE_LIBRARY = eINSTANCE.getMovieLibrary();

		/**
		 * The meta object literal for the '{@link genericAttributes.impl.AbstractEntryImpl <em>Abstract Entry</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see genericAttributes.impl.AbstractEntryImpl
		 * @see genericAttributes.impl.GenericAttributesPackageImpl#getAbstractEntry()
		 * @generated
		 */
		EClass ABSTRACT_ENTRY = eINSTANCE.getAbstractEntry();

		/**
		 * The meta object literal for the '
		 * {@link genericAttributes.impl.BookImpl <em>Book</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see genericAttributes.impl.BookImpl
		 * @see genericAttributes.impl.GenericAttributesPackageImpl#getBook()
		 * @generated
		 */
		EClass BOOK = eINSTANCE.getBook();

		/**
		 * The meta object literal for the '
		 * {@link genericAttributes.impl.MovieImpl <em>Movie</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see genericAttributes.impl.MovieImpl
		 * @see genericAttributes.impl.GenericAttributesPackageImpl#getMovie()
		 * @generated
		 */
		EClass MOVIE = eINSTANCE.getMovie();

		/**
		 * The meta object literal for the '{@link genericAttributes.impl.SciFiImpl <em>Sci Fi</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see genericAttributes.impl.SciFiImpl
		 * @see genericAttributes.impl.GenericAttributesPackageImpl#getSciFi()
		 * @generated
		 */
		EClass SCI_FI = eINSTANCE.getSciFi();

		/**
		 * The meta object literal for the '{@link genericAttributes.impl.ComedyImpl <em>Comedy</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see genericAttributes.impl.ComedyImpl
		 * @see genericAttributes.impl.GenericAttributesPackageImpl#getComedy()
		 * @generated
		 */
		EClass COMEDY = eINSTANCE.getComedy();

	}

} // GenericAttributesPackage
