package genericAttributes;

import com.example.IPerformanceTestDispatcher;

public class GenericAttributesPerformanceTestDispatcher implements
		IPerformanceTestDispatcher {

	private AccessType accessType;
	private final BookLibrary library;
	private final LibraryStatistics libraryStatistics;
	private final LibraryStatisticsInstanceof libraryStatisticsInstanceof;
	private final LibraryStatisticsDispatch libraryStatisticsDispatch;

	public GenericAttributesPerformanceTestDispatcher(int count) {
		this.library = createGenericAttributeBookLibrary(count);
		this.libraryStatistics = new LibraryStatistics();
		this.libraryStatisticsInstanceof = new LibraryStatisticsInstanceof();
		this.libraryStatisticsDispatch = new LibraryStatisticsDispatch();
	}

	@Override
	public void computeStatistics() {
		switch (accessType) {
		case GENERIC:
			libraryStatistics.countEntries(library);
			break;
		case SPECIFIC:
			libraryStatistics.countBooks(library);
			break;
		}
	}

	@Override
	public void computeInstanceof() {
		switch (accessType) {
		case GENERIC:
			libraryStatisticsInstanceof.countEntries(library);
			break;
		case SPECIFIC:
			libraryStatisticsInstanceof.countBooks(library);
			break;
		}
	}

	@Override
	public void computeDispatch() {
		switch (accessType) {
		case GENERIC:
			libraryStatisticsDispatch.countEntries(library);
			break;
		case SPECIFIC:
			libraryStatisticsDispatch.countBooks(library);
			break;
		}
	}

	private static genericAttributes.BookLibrary createGenericAttributeBookLibrary(
			int count) {
		return GenericAttributesTest.createBookLibrary(count);
	}

	@Override
	public void setAccessType(AccessType accessType) {
		this.accessType = accessType;
	}
}
