package genericAttributes;

import com.example.MetamodelException;
import com.google.common.collect.Iterables;

public class LibraryStatisticsInstanceof implements GenericAttributesCountable {
	public int countEntries(AbstractLibrary library) {
		if (library instanceof BookLibrary) {
			return ((BookLibrary) library).getBooks().size();
		} else if (library instanceof MovieLibrary) {
			return ((MovieLibrary) library).getMovies().size();
		} else {
			throw new MetamodelException(library);
		}
	}

	@Override
	public int countBooks(BookLibrary library) {
		return Iterables
				.size(Iterables.filter(library.getEntries(), Book.class));
	}
}
