/**
 */
package genericUnitypeAttributes.util;

import genericUnitypeAttributes.AbstractEntry;
import genericUnitypeAttributes.AbstractLibrary;
import genericUnitypeAttributes.Book;
import genericUnitypeAttributes.BookLibrary;
import genericUnitypeAttributes.Comedy;
import genericUnitypeAttributes.GenericUnitypeAttributesPackage;
import genericUnitypeAttributes.Movie;
import genericUnitypeAttributes.MovieLibrary;
import genericUnitypeAttributes.SciFi;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides
 * an adapter <code>createXXX</code> method for each class of the model. <!--
 * end-user-doc -->
 * @see genericUnitypeAttributes.GenericUnitypeAttributesPackage
 * @generated
 */
public class GenericUnitypeAttributesAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static GenericUnitypeAttributesPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public GenericUnitypeAttributesAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = GenericUnitypeAttributesPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code> if
	 * the object is either the model's package or is an instance object of the
	 * model. <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected GenericUnitypeAttributesSwitch<Adapter> modelSwitch = new GenericUnitypeAttributesSwitch<Adapter>() {
			@Override
			public Adapter caseAbstractLibrary(AbstractLibrary object) {
				return createAbstractLibraryAdapter();
			}
			@Override
			public Adapter caseBookLibrary(BookLibrary object) {
				return createBookLibraryAdapter();
			}
			@Override
			public Adapter caseMovieLibrary(MovieLibrary object) {
				return createMovieLibraryAdapter();
			}
			@Override
			public Adapter caseAbstractEntry(AbstractEntry object) {
				return createAbstractEntryAdapter();
			}
			@Override
			public Adapter caseBook(Book object) {
				return createBookAdapter();
			}
			@Override
			public Adapter caseMovie(Movie object) {
				return createMovieAdapter();
			}
			@Override
			public Adapter caseSciFi(SciFi object) {
				return createSciFiAdapter();
			}
			@Override
			public Adapter caseComedy(Comedy object) {
				return createComedyAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}

	/**
	 * Creates a new adapter for an object of class '{@link genericUnitypeAttributes.AbstractLibrary <em>Abstract Library</em>}'.
	 * <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see genericUnitypeAttributes.AbstractLibrary
	 * @generated
	 */
	public Adapter createAbstractLibraryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link genericUnitypeAttributes.BookLibrary <em>Book Library</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see genericUnitypeAttributes.BookLibrary
	 * @generated
	 */
	public Adapter createBookLibraryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link genericUnitypeAttributes.MovieLibrary <em>Movie Library</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see genericUnitypeAttributes.MovieLibrary
	 * @generated
	 */
	public Adapter createMovieLibraryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link genericUnitypeAttributes.AbstractEntry <em>Abstract Entry</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see genericUnitypeAttributes.AbstractEntry
	 * @generated
	 */
	public Adapter createAbstractEntryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link genericUnitypeAttributes.Book <em>Book</em>}'.
	 * <!-- begin-user-doc
	 * --> This default implementation returns null so that we can easily ignore
	 * cases; it's useful to ignore a case when inheritance will catch all the
	 * cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see genericUnitypeAttributes.Book
	 * @generated
	 */
	public Adapter createBookAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link genericUnitypeAttributes.Movie <em>Movie</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see genericUnitypeAttributes.Movie
	 * @generated
	 */
	public Adapter createMovieAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link genericUnitypeAttributes.SciFi <em>Sci Fi</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see genericUnitypeAttributes.SciFi
	 * @generated
	 */
	public Adapter createSciFiAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link genericUnitypeAttributes.Comedy <em>Comedy</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see genericUnitypeAttributes.Comedy
	 * @generated
	 */
	public Adapter createComedyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc --> This
	 * default implementation returns null. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} // GenericUnitypeAttributesAdapterFactory
