package genericAttributes;

import genericAttributes.AbstractLibrary;
import genericAttributes.Book;
import genericAttributes.BookLibrary;
import genericAttributes.GenericAttributesCountable;
import genericAttributes.Movie;
import genericAttributes.MovieLibrary;
import java.util.Arrays;
import org.eclipse.emf.common.util.EList;

@SuppressWarnings("all")
public class LibraryStatisticsDispatch implements GenericAttributesCountable {
  protected int _countEntries(final BookLibrary library) {
    EList<Book> _books = library.getBooks();
    return _books.size();
  }
  
  protected int _countEntries(final MovieLibrary library) {
    EList<Movie> _movies = library.getMovies();
    return _movies.size();
  }
  
  public int countBooks(final BookLibrary library) {
    EList<Book> _books = library.getBooks();
    return _books.size();
  }
  
  public int countEntries(final AbstractLibrary library) {
    if (library instanceof BookLibrary) {
      return _countEntries((BookLibrary)library);
    } else if (library instanceof MovieLibrary) {
      return _countEntries((MovieLibrary)library);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(library).toString());
    }
  }
}
